/*
 * DO NOT EDIT THIS FILE - it is generated by Glade.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

void insert_icons_into_group (IconGroup * new_icon_group);


gchar * CompizSettings_backend_get_plugin_description(gchar * plugin_name) {
 gchar * plugin_description;

  	if (!strmatch(plugin_name, " ")) {
    	    plugin_description = CompizSettings_get_description(plugin_name);
	   if (plugin_description == NULL) {
	     plugin_description = g_strdup_printf("No Description");
	   }
  	} else {
	     plugin_description = g_strdup_printf("No Description");
	}


 return plugin_description;
}

GtkWidget * icon_selection_new_icon(gchar * key, gchar * image_path, gchar * plugin_name, gchar * description, GFunc * click_cb, gpointer * cb_data, gboolean has_checkbox) {
  	GtkWidget * hbox;
  	GtkWidget * title_hbox;
	GtkWidget * vbox;
	GtkWidget * label;
	GtkWidget * image;
	GtkWidget * checkbox;
	GtkWidget * eventbox;
        GtkTooltips *button_bar_tips;

   	button_bar_tips = gtk_tooltips_new ();
	gchar * title = CompizSettings_backend_get_plugin_title(plugin_name);

	  hbox = gtk_hbox_new (FALSE, 0);
  	  eventbox = gtk_button_new ();

          /* hack because I can't be bothered to convert everything to plugin filter and it works fine */
	   gtk_widget_set_name (GTK_WIDGET (eventbox), plugin_name);

          gtk_button_set_relief (GTK_BUTTON (eventbox), GTK_RELIEF_NONE);

  	  gtk_container_add (GTK_CONTAINER (eventbox), hbox);

        gtk_widget_set_size_request (hbox, ICON_WIDTH, 55);

  	image = create_pixmap (window1, image_path);
        gtk_widget_set_size_request (image, 55, -1);
  	gtk_box_pack_start (GTK_BOX (hbox), image, FALSE, FALSE, 0);
  	gtk_misc_set_alignment (GTK_MISC (image), 0, 0);
  	gtk_misc_set_padding (GTK_MISC (image), 0, 0);

  	vbox = gtk_vbox_new (FALSE, 0);
  	gtk_box_pack_start (GTK_BOX (hbox), vbox, FALSE, FALSE, 0);

  	GtkWidget * alignment = gtk_alignment_new (0.5, 0.5, 1, 1);
  	gtk_widget_set_size_request (alignment, -1, 10);
  	gtk_box_pack_start (GTK_BOX (vbox), alignment, FALSE, FALSE, 0);
	Plugin_Filter_Button * button_data = malloc(sizeof(Plugin_Filter_Button));
  	title_hbox = gtk_hbox_new (FALSE, 0);
	if (has_checkbox) {
         gtk_tooltips_set_tip (GTK_TOOLTIPS (button_bar_tips), eventbox, "Single Click to configure, Right click to toggle activation", NULL);

	 checkbox = gtk_check_button_new();
  	 gtk_box_pack_start (GTK_BOX (title_hbox), checkbox, FALSE, FALSE, 0);
	 button_data->checkbox = checkbox;

	  if (data_is_in_gslist(active_plugins, plugin_name)) {
	    button_data->checkbox_active = TRUE;
	        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbox), TRUE);
	  } else {
	    button_data->checkbox_active = FALSE;
	        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbox), FALSE);
	  }
	   backend_create_new_callback(COMPIZ_PATH "/general/allscreens/options/active_plugins", (GFunc *) active_plugins_changed_checkbox, (GtkWidget *) button_data);
	} else {
	  button_data->checkbox = NULL;
	}
	   button_data->plugin_name = plugin_name;
  	   if (!cb_data) {
	      cb_data = (gpointer *) button_data;
	   }
           g_signal_connect ((gpointer) eventbox, "button_press_event", G_CALLBACK (click_cb),  cb_data);

	 gchar * title_label_text = g_strdup_printf("<b>%s</b>", title);
  	 label = gtk_label_new (title_label_text);
	 g_free(title_label_text);

  	gtk_label_set_use_markup (GTK_LABEL (label), TRUE);
  	gtk_box_pack_start (GTK_BOX (title_hbox), label, FALSE, FALSE, 0);

  	gtk_box_pack_start (GTK_BOX (vbox), title_hbox, FALSE, FALSE, 0);

	 gchar * label_text = g_strdup_printf("<span size=\"small\">%s</span>", description);
  	 label = gtk_label_new (label_text);
	 g_free(label_text);
	GdkColor * color = malloc(sizeof(GdkColor));
	gdk_color_parse ("#525252", color);
        gtk_widget_modify_fg (label,GTK_STATE_NORMAL, color);
	//gdk_color_free(color);
  	gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 0);

  	gtk_label_set_use_markup (GTK_LABEL (label), TRUE);
  	gtk_misc_set_alignment (GTK_MISC (label), 0, 0);
  	gtk_misc_set_padding (GTK_MISC (label), 0, 0);

	gtk_widget_show_all(eventbox);

   return eventbox;
}



void add_icon_to_group_table(gchar * plugin_name, gchar * image_path, IconGroup * new_icon_group, GFunc * click_cb, gpointer * cb_data, gboolean has_checkbox) {
   if (number_of_cols == new_icon_group->current_col) {
	 new_icon_group->current_row++;
	 new_icon_group->current_col = 0;
   }


  /* Append a row and fill in some data */
   gchar * plugin_description = CompizSettings_backend_get_plugin_description(plugin_name);
   GtkWidget * hbox = icon_selection_new_icon(plugin_name, image_path, plugin_name, plugin_description, click_cb, cb_data, has_checkbox);
   g_free(plugin_description);


   gtk_table_attach (GTK_TABLE (new_icon_group->table), hbox, new_icon_group->current_col, new_icon_group->current_col+1, new_icon_group->current_row, new_icon_group->current_row+1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
   new_icon_group->current_col++;




}


GtkWidget * icon_selection_error_notice(gchar * error_title, gchar * description) {
  GtkWidget * alignment;
  GtkWidget * hbox;
  GtkWidget * vbox;
  GtkWidget * widget;
   hbox = gtk_hbox_new (FALSE, 0);
    alignment = gtk_alignment_new (0.5, 0.5, 1, 1);
     gtk_widget_set_size_request (alignment, 30, -1);
     gtk_box_pack_start (GTK_BOX (hbox), alignment, FALSE, FALSE, 0);

   widget =create_pixmap(window1, "warning.png");
   gtk_box_pack_start (GTK_BOX (hbox), widget, FALSE, FALSE, 0);

   vbox = gtk_vbox_new (FALSE, 0);
	widget = new_section_title(error_title);
    gtk_misc_set_padding (GTK_MISC (widget), 0, 20);
   gtk_box_pack_start (GTK_BOX (vbox), widget, FALSE, FALSE, 0);

	widget = gtk_label_new(description);
  gtk_label_set_use_markup (GTK_LABEL (widget), TRUE);
   gtk_misc_set_alignment (GTK_MISC (widget), 0, 0);
   gtk_box_pack_start (GTK_BOX (vbox), widget, FALSE, FALSE, 0);

   gtk_box_pack_start (GTK_BOX (hbox), vbox, FALSE, FALSE, 0);

 return hbox;
}


void insert_plugin_icons_into_group (IconGroup * new_icon_group) {
  GtkWidget * table = gtk_table_new (2, 3, FALSE);
  gboolean added_at_least_one_plugin = FALSE;


  new_icon_group->regenerate_func = (GFunc) *insert_plugin_icons_into_group;
  new_icon_group->current_col=0;
  new_icon_group->current_row=0;
  new_icon_group->table = table;
	
	GSList * starting_gslist = malloc(sizeof(GSList *));
	starting_gslist = Plugins_list;

	for (; Plugins_list; Plugins_list = Plugins_list->next) {
	 /* Filer plugins */
	 gchar * plugin_name = g_path_get_basename(Plugins_list->data);
         gchar * image_path = get_image_path(plugin_name);
            if (!CompizSettings_plugin_is_advanced(plugin_name) || medium_interface == FALSE) {

	  if (global_icon_filter != NULL && strlen(global_icon_filter) > 0) {
	     if(strmatch(plugin_name, global_icon_filter) == 1) {
		   added_at_least_one_plugin = TRUE;
	    	   add_icon_to_group_table(Plugins_list->data, image_path, new_icon_group, (GFunc *)plugin_button_clicked, (gpointer *) NULL, TRUE);
	        }
	  } else {
		   added_at_least_one_plugin = TRUE;
	    	   add_icon_to_group_table(Plugins_list->data, image_path, new_icon_group, (GFunc *)plugin_button_clicked, (gpointer *) NULL, TRUE);
	  }

	}
	g_free(image_path);

	}
	/* Reset List */
	Plugins_list = starting_gslist;

 	if (!added_at_least_one_plugin && global_icon_filter != NULL && strlen(global_icon_filter) > 0) {
  	   GtkWidget * error = icon_selection_error_notice("No plugins found", g_strdup_printf("Your filter for <b>%s</b> did not match any results", global_icon_filter));
	   gtk_box_pack_start (GTK_BOX (new_icon_group->container), error, FALSE, FALSE, 0);
	   safe_gtk_widget_destroy(new_icon_group->table);
	   new_icon_group->table = error;
 	} else {
	   gtk_box_pack_start (GTK_BOX (new_icon_group->container), table, FALSE, FALSE, 0);
	}

  gtk_widget_show_all(new_icon_group->container);

}



void insert_manual_icons_into_group (IconGroup * new_icon_group) {
  GtkWidget * manual_table;
     manual_table = gtk_table_new (0, 0, FALSE);

  gtk_box_pack_start (GTK_BOX (new_icon_group->container), manual_table, FALSE, FALSE, 0);

  new_icon_group->regenerate_func = (GFunc) *insert_manual_icons_into_group;
  new_icon_group->current_col=0;
  new_icon_group->current_row=0;
  new_icon_group->table = manual_table;

  add_icon_to_group_table("CompizSettings_general", "general.png", new_icon_group, (GFunc *)plugin_button_clicked, (gpointer *)NULL, FALSE);


  gtk_widget_show_all(new_icon_group->container);

}


IconGroup * icon_selection_new_icon_group(gchar * title) {
  GtkWidget * eventbox;
  GtkWidget * vbox;
  GtkWidget * label;


  IconGroup * new_icon_group = malloc(sizeof(IconGroup));
 
  eventbox = gtk_event_box_new ();
  vbox = gtk_vbox_new (FALSE, 0);

  gtk_container_add (GTK_CONTAINER (eventbox), vbox);

  label = gtk_label_new (g_strdup_printf("<span size=\"x-large\">%s</span>", title));
  gtk_misc_set_padding (GTK_MISC (label), 10, 0);
  gtk_label_set_use_markup (GTK_LABEL (label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (label), 0, 0);

   GdkColor * label_color = malloc(sizeof(GdkColor));
   gdk_color_parse ("#767676", label_color);
   gtk_widget_modify_fg (label,GTK_STATE_NORMAL,label_color);

  gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 0);

  gtk_widget_modify_bg (eventbox, GTK_STATE_NORMAL, &color);

  GtkWidget * vbox1 = gtk_vbox_new (FALSE, 0);

  GtkWidget * hbox1 = gtk_hbox_new (FALSE, 0);
  GtkWidget * alignment = gtk_alignment_new (0.5, 0.5, 1, 1);
  gtk_widget_set_size_request (alignment, 20, -1);
  gtk_box_pack_start (GTK_BOX (hbox1), alignment, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox1, FALSE, FALSE, 1);

  gtk_box_pack_start (GTK_BOX (vbox), hbox1, FALSE, FALSE, 1);

  new_icon_group->group_name = title; 
  new_icon_group->container = vbox1; 
  new_icon_group->eventbox = eventbox; 
  new_icon_group->screen_options_list = NULL; 
  new_icon_group->allscreen_options_list = NULL; 
  new_icon_group->icons_list = NULL;

  return new_icon_group;
}


void create_aboutdialog1 (void)
{
  GtkWidget *aboutdialog1;
  const gchar *authors[] = {
    "Ben Reeves - (zootreeves)",
    NULL
  };
  const gchar *artists[] = {
    "Ben Reeves",
    "Wedderburn",
    NULL
  };
  /* TRANSLATORS: Replace this string with your names, one name per line. */
  gchar *translators = "translator-credits";
  GdkPixbuf *aboutdialog1_logo_pixbuf;

  aboutdialog1 = gtk_about_dialog_new ();
  gtk_window_set_position (GTK_WINDOW (aboutdialog1), GTK_WIN_POS_CENTER);
  gtk_window_set_destroy_with_parent (GTK_WINDOW (aboutdialog1), TRUE);
  gtk_about_dialog_set_version (GTK_ABOUT_DIALOG (aboutdialog1), VERSION);
  gtk_about_dialog_set_name (GTK_ABOUT_DIALOG (aboutdialog1), "Compiz-Settings");
  gtk_about_dialog_set_copyright (GTK_ABOUT_DIALOG (aboutdialog1), "Copyright 2006 - Ben Reeves - zootreeves@gmail.com");
  gtk_about_dialog_set_comments (GTK_ABOUT_DIALOG (aboutdialog1), "Compiz is not beryl!");
  gtk_about_dialog_set_license (GTK_ABOUT_DIALOG (aboutdialog1), " * Version: MPL 1.1  \n * \n * The contents of this file are subject to the Mozilla Public License Version\n * 1.1 (the \"License\"); you may not use this file except in compliance with\n * the License. You may obtain a copy of the License at\n * http://www.mozilla.org/MPL/\n *\n * Software distributed under the License is distributed on an \"AS IS\" basis,\n * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License\n * for the specific language governing rights and limitations under the\n * License.\n *\n * The Original Code is C\n *\n * The Initial Developer of the Original Code is\n * Ben Reeves.\n * Portions created by the Initial Developer are Copyright (C) 2006\n * the Initial Developer. All Rights Reserved.\n *\n *");
  gtk_about_dialog_set_wrap_license (GTK_ABOUT_DIALOG (aboutdialog1), TRUE);
  gtk_about_dialog_set_website (GTK_ABOUT_DIALOG (aboutdialog1), "http://go-compiz.org");
  gtk_about_dialog_set_website_label (GTK_ABOUT_DIALOG (aboutdialog1), "Compiz Homepage");
  gtk_about_dialog_set_authors (GTK_ABOUT_DIALOG (aboutdialog1), authors);
  gtk_about_dialog_set_artists (GTK_ABOUT_DIALOG (aboutdialog1), artists);
  gtk_about_dialog_set_translator_credits (GTK_ABOUT_DIALOG (aboutdialog1), translators);
  aboutdialog1_logo_pixbuf = create_pixbuf ("logo.png");
  gtk_about_dialog_set_logo (GTK_ABOUT_DIALOG (aboutdialog1), aboutdialog1_logo_pixbuf);

  g_signal_connect ((gpointer) aboutdialog1, "response",
                    G_CALLBACK (gtk_widget_destroy),
                    NULL);


  gtk_widget_show(aboutdialog1);
}



GtkWidget * set_up_left_pane() {
  GtkWidget * widget;
  GtkWidget * vbox;

  vbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_size_request (vbox, 200, -1);


  GtkWidget * alignment = gtk_alignment_new (0.5, 0.5, 1, 1);
  gtk_widget_set_size_request (alignment, -1, 10);
  gtk_box_pack_start (GTK_BOX (vbox), alignment, FALSE, FALSE, 0);


  widget = new_section_title("Navigation");
  gtk_box_pack_start (GTK_BOX (vbox), widget, FALSE, FALSE, 0);
  widget = new_label_button(10, "Main Panel", (GFunc *) interface_go_back, "gtk-home");
  gtk_box_pack_start (GTK_BOX (vbox), widget, FALSE, FALSE, 0); 


  widget = new_section_title("Filter");
  gtk_box_pack_start (GTK_BOX (vbox), widget, FALSE, FALSE, 0);
  	widget = gtk_entry_new();
	g_signal_connect (GTK_WIDGET (widget), "changed", G_CALLBACK(filter_text_changed), NULL);
	GtkWidget * hbox = gtk_hbox_new (FALSE, 0);
 	alignment = gtk_alignment_new (0.5, 0.5, 1, 1);
  	gtk_widget_set_size_request (alignment, 13, -1);

  	gtk_box_pack_start (GTK_BOX (hbox), alignment, FALSE, FALSE, 0);
  	gtk_box_pack_start (GTK_BOX (hbox), widget, TRUE, TRUE, 0);

 	alignment = gtk_alignment_new (0.5, 0.5, 1, 1);
  	gtk_widget_set_size_request (alignment, 13, -1);
  	gtk_box_pack_start (GTK_BOX (hbox), alignment, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);


  alignment = gtk_alignment_new (0.5, 0.5, 1, 1);
  gtk_widget_set_size_request (alignment, -1, 10);
  gtk_box_pack_start (GTK_BOX (vbox), alignment, FALSE, FALSE, 0);

  left_vbox->common_tasks = gtk_vbox_new (FALSE, 0);
  	widget = new_section_title("Common Tasks");
  	gtk_box_pack_start (GTK_BOX (left_vbox->common_tasks), widget, FALSE, FALSE, 0);

  	left_vbox->reset_default = new_label_button(10, "Reset All To Default", (GFunc *) reset_to_default, NULL);
  	gtk_box_pack_start (GTK_BOX (left_vbox->common_tasks), left_vbox->reset_default, FALSE, FALSE, 0);

  gtk_box_pack_start (GTK_BOX (vbox), left_vbox->common_tasks, FALSE, FALSE, 0);

  widget = new_section_title("Preferences");
  gtk_box_pack_start (GTK_BOX (vbox), widget, FALSE, FALSE, 0);
  widget = new_label_button(10, "Show All Options", (GFunc *) interface_change_button_clicked, NULL);
  gtk_box_pack_start (GTK_BOX (vbox), widget, FALSE, FALSE, 0);

  /* Take up extra space so widget so can be pushed to the bottom */
  widget = gtk_alignment_new (0.5, 0.5, 1, 1);
  gtk_box_pack_start (GTK_BOX (vbox), widget, TRUE, TRUE, 0);

  widget = new_label_button(0, "About", (GFunc *) create_aboutdialog1, NULL);
  gtk_box_pack_start (GTK_BOX (vbox), widget, FALSE, FALSE, 0);


  gtk_box_pack_start (GTK_BOX (main_hbox), vbox, FALSE, TRUE, 0);

 return vbox;
}




GtkWidget* create_window1 (void)
{
  GtkWidget * widget;
  GtkWidget * vbox;

  window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);

  gtk_window_set_title (GTK_WINDOW (window1), "Compiz Configuration");
  GdkPixbuf * window_icon_pixbuf = create_pixbuf("logo.png");
    gtk_window_set_icon (GTK_WINDOW (window1), window_icon_pixbuf);
  gtk_window_set_default_size     (GTK_WINDOW(window1), 910, 600);
	gdk_color_parse ("white", &color);

  main_hbox = gtk_hbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (window1), main_hbox);

  left_vbox = malloc(sizeof(LeftVbox));
  vbox = set_up_left_pane();

  icon_selection_vbox = gtk_vbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (main_hbox), icon_selection_vbox, TRUE, TRUE, 0);

  widget = gtk_scrolled_window_new (NULL, NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (widget), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_box_pack_start (GTK_BOX (icon_selection_vbox), widget, TRUE, TRUE, 0);
  vbox = gtk_vbox_new (FALSE, 0);
  gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW(widget), vbox);

  GtkWidget * eventbox = gtk_event_box_new ();
  gtk_widget_modify_bg (eventbox, GTK_STATE_NORMAL, &color);
  gtk_box_pack_start (GTK_BOX (vbox), eventbox, TRUE, TRUE, 0);
   vbox = gtk_vbox_new (FALSE, 0);
   gtk_container_add (GTK_CONTAINER (eventbox), vbox);
  gtk_widget_show_all(eventbox);


 if (backend_is_setup() == TRUE) {
  IconGroup * new_icon_group;
  new_icon_group = icon_selection_new_icon_group("General");
  icon_groups = g_slist_append(icon_groups, new_icon_group);
  insert_manual_icons_into_group(new_icon_group);
  gtk_box_pack_start (GTK_BOX (vbox), new_icon_group->eventbox, FALSE, FALSE, 0);

  new_icon_group = icon_selection_new_icon_group("Plugins");
  icon_groups = g_slist_append(icon_groups, new_icon_group);
  insert_plugin_icons_into_group(new_icon_group);
  gtk_box_pack_start (GTK_BOX (vbox), new_icon_group->eventbox, FALSE, FALSE, 0);


/* This should really be groups_window_resized and icon_groups */
  g_signal_connect ((gpointer) icon_selection_vbox, "size_allocate",
                    G_CALLBACK (groups_window_resized),
                    icon_groups);

 } else {

  GtkWidget * error = icon_selection_error_notice("Compiz is not installed correctly!", "The compiz gconf schema appears not to be installed correctly\nare you sure compiz is installed <b>with gconf support?</b>");
  gtk_box_pack_start (GTK_BOX (vbox), error, TRUE, FALSE, 0);

 }


  return window1;
} 

